﻿@model IEnumerable<WebFBX.Models.DescuentosModels>

@{
    Layout = null;
    int i = 0;

}

<table id="table_descuentos" class="table-striped table-bordered tableSection table_consulta cursor_table" cellspacing="0" width="100%" data-role="datatable">
    <thead>
        <tr>

            <th style="width:20%">
                Código
            </th>
            <th style="width:7%">
                Tipo
            </th>
            <th style="width:25%">
                Cantidad
            </th>
            <th style="width:25%">
                Valor
            </th>
            <th style="width:18%">
                Consumido
            </th>
            <th style="width:5%" class="text-center">
                <i class="fa fa-trash" aria-hidden="true" style="font-size: 14px"></i>
            </th>

        </tr>
    </thead>
    <tbody>

        @foreach (var item in Model)
        {
            i++;
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.codigo)
            </td>
            <td>
                @if (item.tipo == 0)
                {
                    <select id="tipodescuento_@i" class="form-control form-control-sm">
                        <option value="0" selected>$</option>
                        <option value="1">%</option>
                    </select>
                }
                else
                {
                    <select id="tipodescuento_@i" class="form-control tipodescuento form-control-sm" data-fila="@i">
                        <option value="0">$</option>
                        <option value="1" selected>%</option>
                    </select>
                }

            </td>
            <td>
                <input type="text" id="cantidad_@i" value="@item.cantidad" data-codigo="@item.codigo" class="form-control form-control-sm color_text_dt_input_select campo" onblur="this.value = numberFormat_decimal(this.value);" onkeypress="return validateEnteroKeyPress(this,event);" data-campo="cantidad" />
            </td>
            <td>
                @if (item.tipo == 0)
                {
                    <input type="text" id="valor_@i" value="@item.valor.ToString("N0")" data-fila="@i" data-codigo="@item.codigo" class="form-control form-control-sm color_text_dt_input_select campo_valor text-right" onblur="this.value = numberFormat_decimal(this.value);" onkeypress="return validateEnteroKeyPress(this,event);" data-campo="valor" />
                }
                else
                {
                    <input type="text" id="valor_@i" value="@item.valor.ToString("N2")" data-fila="@i" data-codigo="@item.codigo" class="form-control form-control-sm color_text_dt_input_select campo_valor text-right" onkeypress="return SoloNumerosDecimalesComa(event, '0,1', 2, 1)" data-campo="valor" />
                }
            </td>
            <td>
                <input type="text" id="consumido_@i" value="@item.consumido" data-codigo="@item.codigo" class="form-control form-control-sm color_text_dt_input_select campo text-right" onblur="this.value = numberFormat_decimal(this.value);" onkeypress="return validateEnteroKeyPress(this,event);" data-campo="consumido" />
            </td>
            <td class="text-center">
                <i class="fas fa-trash-alt borrar_fila_descuento text-center" style="font-size: 16px; color: red; cursor: pointer" id="idborrar_@i.ToString()" data-codigo="@item.codigo"></i>
            </td>
        </tr>
        }
    </tbody>
</table>

<script type="text/javascript" class="init">

    $(document).ready(function () {
        table_descuentos = $('#table_descuentos').DataTable({
            destroy: true,
            "bInfo": true,
            "bPaginate": true,
            "searching": true,
            "bSort": false,
            "scrollX": true,
            "lengthMenu": [[10, 15, 45, 75, 105, 135, 165, 195, 225, 255, 285], [10, 15, 45, 75, 105, 135, 165, 195, 225, 255, 285]],
            "language": {
                "sProcessing": "Procesando...",
                "sLengthMenu": "Mostrar _MENU_ registros",
                "sZeroRecords": "No se encontraron resultados",
                "sEmptyTable": "Ningún dato disponible en esta tabla",
                "sInfo": "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                "sInfoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
                "sInfoFiltered": "(filtrado de un total de _MAX_ registros)",
                "sInfoPostFix": "",
                "sSearch": "Buscar:",
                "sUrl": "",
                "sInfoThousands": ",",
                "sLoadingRecords": "Cargando...",
                "oAria": {
                    "sSortAscending": ": Activar para ordenar la columna de manera ascendente",
                    "sSortDescending": ": Activar para ordenar la columna de manera descendente"
                },
                "paginate": {
                    "previous": "Anterior",
                    "next": "Siguiente"
                }
            },
            fixedHeader: {
                header: true,
                footer: true
            },

        });
        $('#table_descuentos tbody').on('change', '.tipodescuento', function (e) {
            e.preventDefault();
            var fila = $(this).data('fila');
            $("#valor_" + fila).val("");
            $("#valor_" + fila).val("");
            if ($(this).val() == "1") {
                $("#valor_" + fila).attr("onkeypress", "return SoloNumerosDecimalesComa(event, '0,1', 2, 1)");
            } else {
                $("#valor_" + fila).attr("onkeypress", "return validateEnteroKeyPress(this,event)");
            }
        });

        $('#table_descuentos tbody').on('change', '.campo_valor', function (e) {
            e.preventDefault();
            var fila = $(this).data('fila');
            var tipo=$("#tipodescuento_" + fila).val();

            var codigo = $(this).data('codigo');
            var campo = $(this).data('campo');
            var valor_input = $(this).val().toString().replace(/\./g, '').replace(/\,/g, '.');
            var fd = new FormData();
            fd.append("codigo", codigo);
            fd.append("campo", campo);
            fd.append("tipo", tipo);
            fd.append("valor_input", valor_input);
            $.ajax({
                type: "POST",
                url: '/Descuentos/EditarDescuentoValor/',
                data: fd,
                contentType: false,
                processData: false,
                DataType: 'json',
                success: function (data) {
                    if (data == "1") {
                        console.log("Descuento actualizado correctamente");
                    }
                    else {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + data);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de conexion al guardar: " + errorThrown);
                }
            });
        });

        $('#table_descuentos tbody').on('change', '.campo', function (e) {
            e.preventDefault();
            
            var codigo = $(this).data('codigo');
            var campo = $(this).data('campo');
            var valor_input = $(this).val().toString().replace(/\./g, '');
            var fd = new FormData();
            fd.append("codigo", codigo);
            fd.append("campo", campo);
            fd.append("valor_input", valor_input);
            $.ajax({
                type: "POST",
                url: '/Descuentos/EditarDescuento/',
                data: fd,
                contentType: false,
                processData: false,
                DataType: 'json',
                success: function (data) {
                    if (data == "1") {
                        console.log("Descuento actualizado correctamente");
                    }
                    else {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + data);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de conexion al guardar: " + errorThrown);
                }
            });
        });

        $('#table_descuentos tbody').on('click', '.borrar_fila_descuento', function (e) {
            e.preventDefault();
            var codigo = $(this).data('codigo');
            $("#modaladvertencia_descuento_eliminar").modal("show");
            $("#codigodescuento_eliminar_hidden").val(codigo);
        });
        $('#table_descuentos tbody').on('click', '.editar_foto', function (e) {
            e.preventDefault();
            var referencia = $(this).data('referencia');
            $("#modal_fotos_descuento").modal("show");
            $("#referencia_hidden").val(referencia);
            obtieneFotoEdit(referencia);
        });
    });
</script>



